import { IExtendParsedCommandLine } from '@idlebox/tsconfig-loader';
import { RigConfig } from '@rushstack/rig-package';
import type * as TApiExtractor from '@microsoft/api-extractor';
import type { HeftConfiguration } from '@rushstack/heft';
import type { ITypeScriptConfigurationJson } from '@rushstack/heft/lib/plugins/TypeScriptPlugin/TypeScriptPlugin';
export declare function loadHeftConfig(heftConfiguration: HeftConfiguration): RushStackConfig;
export interface IWarning {
    (message: string): void;
}
export declare class RushStackConfig {
    private readonly warning;
    private typescriptConfig?;
    private tsconfigConfig?;
    private apiExtractorConfig?;
    private readonly rigConfig;
    private readonly localRequire;
    private readonly rigRequire?;
    private readonly localRequirePath;
    private readonly rigRequirePath?;
    readonly projectFolder: string;
    /**
     *
     * @param projectFolder absolute path of directory where the package.json is in
     */
    constructor(projectFolder: string, rigConfig?: RigConfig, warning?: IWarning);
    private resolveConfigFile;
    private loadRig;
    require(packageName: string): any;
    resolve(packageName: string): string;
    apiExtractor(): TApiExtractor.IConfigFile | undefined;
    typescript(): ITypeScriptConfigurationJson;
    tsconfigPath(): string;
    tsconfig(): IExtendParsedCommandLine;
}
//# sourceMappingURL=api.d.ts.map